package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.StringUtils;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmSeriouslyIllegalAndDishonestList;
import com.zksy.system.basicData.service.CrmSeriouslyIllegalAndDishonestListService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.apache.commons.collections.ListUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 严重违法失信名单Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmSeriouslyIllegalAndDishonestList")
@Api(tags = "严重违法失信名单", description = "严重违法失信名单desc")
public class CrmSeriouslyIllegalAndDishonestListController extends BaseController {

    @Autowired
    private CrmSeriouslyIllegalAndDishonestListService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "严重违法失信名单搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "严重违法失信名单分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "严重违法失信名单查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增严重违法失信名单
     */
    @PostMapping("/save")
    @ApiOperation(value = "严重违法失信名单新增")
    @Log(title = "新增严重违法失信名单", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmSeriouslyIllegalAndDishonestList crmSeriouslyIllegalAndDishonestList) {
        return service.save(crmSeriouslyIllegalAndDishonestList);
    }

    /**
     * 修改严重违法失信名单
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "严重违法失信名单修改")
    @Log(title = "修改严重违法失信名单", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmSeriouslyIllegalAndDishonestList crmSeriouslyIllegalAndDishonestList) {
        return service.updateById(crmSeriouslyIllegalAndDishonestList);
    }

    /**
     * 导入严重违法失信名单
     */
    @ApiOperation("严重违法失信名单导入")
    @Log(title = "严重违法失信名单", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmSeriouslyIllegalAndDishonestList> crmSeriouslyIllegalAndDishonestListAll = service.list();
            List<CrmSeriouslyIllegalAndDishonestList> list = ExcelUtils.readMultipartFile(file, CrmSeriouslyIllegalAndDishonestList.class,CrmSeriouslyIllegalAndDishonestList.class.getDeclaredFields().length - 2);
            if(crmSeriouslyIllegalAndDishonestListAll != null && crmSeriouslyIllegalAndDishonestListAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("严重违法失信名单导出")
    @Log(title = "严重违法失信名单", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmSeriouslyIllegalAndDishonestList> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"严重违法失信名单",wrapperList,CrmSeriouslyIllegalAndDishonestList.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "严重违法失信名单", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除严重违法失信名单", notes = "删除严重违法失信名单")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"严重违法失信模板");
    }
}

